# -*- coding: utf-8 -*-
from django.conf.urls.defaults import *
from django.conf import settings

from reiare.asamashie.models import AsamashiWord, AsamashiRakutenXML, AsamashiRakutenGenreXML
from reiare.asamashie.forms import *
#from reiare.asamashie.views import search_form_generate
from reiare.asamashie.feeds import LatestAsamashiWords, LatestItemsByKeyword, LatestItemsByGenre


info_dict = {
    'queryset': AsamashiWord.objects.all(),
    'paginate_by': 50
}

urlpatterns = patterns('',
    #(r'^$', 'django.views.generic.date_based.archive_index', info_dict),
    (r'^$', 'django.views.generic.list_detail.object_list', dict(info_dict,
                                                                 extra_context = {'form': search_form_generate(),
                                                                                  'keyword_counts': AsamashiWord.objects.count(),
                                                                                  'genres': AsamashiRakutenGenreXML.objects.get(genre_id=0).get_dict()['children']})),
)

urlpatterns += patterns('reiare.asamashie.views',
    (r'^(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/page(?P<page>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/pz(?P<price_zone>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/page(?P<page>\d+)/$', 'detail'),
    (r'^(?P<asamashi_word_id>\d+)/$', 'detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/pz(?P<price_zone>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/(?P<sort>[a-z]{3})/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<asamashi_word_id>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<sort>[a-z]{3})/pz(?P<price_zone>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/pz(?P<price_zone>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/pz(?P<price_zone>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<sort>[a-z]{3})/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/(?P<sort>[a-z]{3})/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/page(?P<page>\d+)/$', 'genre_detail'),
    (r'^gid(?P<genre_id>\d+)/search/$', 'genre_search'),
    (r'^gid(?P<genre_id>\d+)/$', 'genre_detail'),
    (r'^search/$', 'search'),
)

feeds = {
    'latest': LatestAsamashiWords,
    'keyword': LatestItemsByKeyword,
    'category': LatestItemsByGenre,
}

urlpatterns += patterns('django.contrib.syndication.views',
    (r'^feeds/(?P<url>.*)/$', 'feed', {'feed_dict': feeds}),
)

