# -*- coding: utf-8 -*-
from django.views.generic.list_detail import object_detail
#from django import newforms as forms
#from django.newforms import *
from django.http import HttpResponseRedirect, Http404, HttpResponseForbidden
from django.db.models.query import Q
from django.shortcuts import render_to_response
from django.contrib.syndication.views import feed

from reiare.asamashie.models import AsamashiWord, AsamashiRakutenGenreXML, AsamashiRakutenXML
from reiare.asamashie.forms import *
from reiare.asamashie.urls import feeds

#class SearchForm(forms.Form):
#    keyword = CharField(label='気になるキーワード', widget=TextInput(attrs={'size': 30}),
#                        help_text='スペース区切りで複数語での検索ができます')

#def search_form_generate(keyword=None):
#    if keyword:
#        form = SearchForm(initial={'keyword': keyword})
#    else:
#        form = SearchForm()
#
#    return form

def asamashi_word_to_qs(asamashi_word):
    qs = []
    for keyword in asamashi_word.keyword.split(' '):
        qs.append(Q(keyword__icontains=keyword))

    fq = None
    for q in qs:
        if fq:
            fq = fq | q
        else:
            fq = q
    return fq

def detail(request, asamashi_word_id, page="1", sort="ipa", price_zone=None):
    try:
        asamashi_word = AsamashiWord.objects.get(pk=asamashi_word_id)
        form = search_form_generate(asamashi_word.keyword)

        #qs = []
        #for keyword in asamashi_word.keyword.split(' '):
        #    qs.append(Q(keyword__icontains=keyword))

        #fq = None
        #for q in qs:
        #    if fq:
        #        fq = fq | q
        #    else:
        #        fq = q
        fq = asamashi_word_to_qs(asamashi_word)
        rel_asamashi_words = AsamashiWord.objects.exclude(pk=asamashi_word.id).filter(fq)[:20]
        
        return object_detail(request, AsamashiWord.objects.all(), object_id=asamashi_word_id,
                             extra_context = {'page': page, 'form': form,
                                              'sort': sort, 'price_zone': price_zone,
                                              'price_zones': [str(n) for n in range(1, 10)],
                                              'recent_objects': AsamashiWord.objects.all()[:20],
                                              'rel_objects': rel_asamashi_words})
    except AsamashiWord.DoesNotExist:
        return HttpResponseRedirect('/asamashie/')

def search_form_to_asamashi_word(form):
    keyword = (form.clean_data['keyword']).replace("　", " ")
    keyword = keyword.strip()
    asamashi_word, created = AsamashiWord.objects.get_or_create(keyword=keyword)
    return asamashi_word
    
def search(request):
    if request.method == "POST":
        form = SearchForm(request.POST)

        if form.is_valid():
            #keyword = (form.clean_data['keyword']).replace("　", " ")
            #keyword = keyword.strip()
            #asamashi_word, created = AsamashiWord.objects.get_or_create(keyword=keyword)
            return HttpResponseRedirect(search_form_to_asamashi_word(form).get_absolute_url())

            #return HttpResponseRedirect(asamashi_word.get_absolute_url())
            #return object_detail(request, AsamashiWord.objects.all(), object_id=asamashi_word.id,
            #                     extra_context = {'page': 1, 'form': form})

    return HttpResponseRedirect("/asamashie/")

def genre_detail(request, genre_id, page="1", sort="ipa", price_zone=None, asamashi_word_id=None):
    rakuten_genre, created = AsamashiRakutenGenreXML.objects.get_or_create(genre_id=genre_id)
    #dict = rakuten_genre.get_dict()
    q = None
    try:
        dict = rakuten_genre.get_dict()
        if dict.has_key('current_genre_name'):
            qs = [Q(keyword__icontains=n) for n in dict['current_genre_name'].split('・')]
            for qq in qs:
                if q:
                    q = qq | q
                else:
                    q = qq
            #q = Q(keyword__icontains=dict['current_genre_name'])
    except:
        return HttpResponseRedirect('/asamashie/')
    
    fq = None
    if asamashi_word_id:
        asamashi_word = AsamashiWord.objects.get(pk=asamashi_word_id)
        form = search_form_generate(asamashi_word.keyword)
        fq = asamashi_word_to_qs(asamashi_word)
    else:
        asamashi_word = None
        form = search_form_generate()

    if fq:
        fq = fq | q
    else:
        fq = q
    rel_asamashi_words = AsamashiWord.objects.filter(fq)[:20]
    #rel_asamashi_words = None
    
    return render_to_response('rakuten_genre_detail.html',
                              {'genre': dict,
                               'object': asamashi_word, 'form': form,
                               'page': page, 'sort': sort, 'price_zone': price_zone,
                               'price_zones': [str(n) for n in range(1, 10)],
                               'recent_objects': AsamashiWord.objects.all()[:20],
                               'rel_objects': rel_asamashi_words})

def genre_search(request, genre_id):
    if request.method == "POST":
        form = SearchForm(request.POST)

        if form.is_valid():
            asamashi_word = search_form_to_asamashi_word(form)
            return HttpResponseRedirect("/asamashie/gid" + str(genre_id) + "/" + str(asamashi_word.id) + "/")
    return HttpResponseRedirect("/asamashie/gid" + str(genre_id)+ "/")
